if(isObject(HUD_HealthBar))
{
	// Reboots the Healthbar
	HUD_HealthBar.delete();
}

if(!isObject(HUD_HealthBar))
{
	// Add the GUI object.
	exec("./HealthBar.gui");
	PlayGUI.add(HUD_HealthBar);
	HUD_HealthBar.setVisible(false);
}

// This function is called when you join a server with the mod activated.
// I originally had the client send this automatically in onConnectionAccepted, but that proved to be unreliable.
function clientCmdDetectHealthBarMod()
{
	commandToServer('RegisterHealthBarMod');
}

// Client command that triggers the HP bar to be adjusted..
function clientCmdSetDamageLevel(%percent)
{
	HUD_HealthBar.setHealthLevel(%percent);
}

// Toggles the healthbar's visibility.
function clientCmdSetHealthBarVisible(%bool)
{
	HUD_HealthBar.setVisible(%bool);
}

function HUD_HealthBar::setHealthLevel(%gui, %dmgPer)
{
	// The client command takes the amount of damage.
	// We want to show the amount of health, so we need to invert the number.
	%percent = 1 - %dmgPer;
	
	if(%percent > 0)
	{
		if(%percent <= 1)
		{
			// Sets the color.
			// mFloor's function is to round down.
			%green = mFloor(255 * %percent); // The higher the health (percent), the more green.
			%red = mFloor(255 * %dmgPer); // The higher the damage (dmgPer), the more red.
			
			%color = %red SPC %green SPC "0 255";
		}
		else
		{
			// If we have more than 100%, go into white mode.
			%color = "255 255 255 255";
		}
		
		HUD_HealthMeter.extent = mFloor(232 * %percent) SPC getWord(HUD_HealthMeter.extent, 1); // Width = maxExtent x currentHP
		HUD_HealthMeter.color = %color;
	}
	else if(%percent == 0)
	{
		// As does the energy bar, if you are killed the bar goes away.
		%gui.setVisible(false);
	}
}

package Healthbar_Client
{	
	// Hides the Healthbar when you leave a server.
	function disconnectedCleanup(%bool)
	{
		HUD_HealthBar.setVisible(false);
		HUD_HealthMeter.extent = "232 7";
		
		return parent::disconnectedCleanup(%bool);
	}
};
activatePackage(Healthbar_Client);
